// OdbcDoc.cpp : implementation of the COdbcDoc class
//

#include "stdafx.h"
#include "Odbc.h"

#include "OdbcDoc.h"
#include "OdbcInst.h"  // Pour fonction gnrale ::SQLxxx
#include "LesProg.h"
#include "LesSujets.h"
#include "LesNbSujetsParProg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COdbcDoc

IMPLEMENT_DYNCREATE(COdbcDoc, CDocument)

BEGIN_MESSAGE_MAP(COdbcDoc, CDocument)
	//{{AFX_MSG_MAP(COdbcDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COdbcDoc construction/destruction

COdbcDoc::COdbcDoc()
	: m_progCourant(&m_demos)  // Cette table sera toujours ouverte, ici on l'associe
	                           //   la bd qu'on ouvrira avant elle dans OnNewDocument
	{
	// TODO: add one-time construction code here
#if 0
	SQLConfigDataSource(NULL, // Fentre parent... car pourrait montrer un b de d.
				ODBC_ADD_DSN, // Ce qu'on veut faire
				"Microsoft Access Driver (*.mdb)", // Le pilote (en fait le nom qu'on veut voir...)
				// Troisime paramtre, le nom du DSN, la source (DBQ), 
				// la description, etc. Il y a d'autres paramtres possibles selon
				// le type de bd. Il s'agit d'un seul paramtre, chaque item spar
				// du suivant par un nul (\0). Attention aux doubles \...
				"DSN=Dmos de VC\0"
				"DBQ=C:\\Mes documents\\odbc\\DmoVC.mdb\0"
                "Description=Base de donnes pour dmo ODBC\0");
				// N.B. On ne peut pas utiliser ConnectString comme on l'a fait, car
	            //      les CString n'aime pas les nuls imbriqus dans les chanes...
	            //      On pourrait mettre cette valeur-ci globale et la transfrer
	            //      dans la connect string par contre...
#endif
	try
		{
		if ( ! m_demos.OpenEx(ConnectString(), CDatabase::noOdbcDialog))
			{
			// Ne devrait jamais arriver ici, car on n'arriverait que si
			// l'usager rpond Annuler  la bote d'information, mais on 
			// a demand noOdbcDialog pour empcher celle-ci. Si la bd ne
			// peut tre accde, on aura une exception...
			//
			// Au cas o, on lve nous-mmes une exception qui dira que la bd
			// n'est pas accessible.
			AfxThrowDBException(AFX_SQL_ERROR_CONNECT_FAIL, NULL, NULL); 
			}

		// Ici on ouvre une table permanente en plus, ce n'est pas toujours
		// utile ou ncessaire...
		if ( ! m_progCourant.Open())
			{
			// Ne devrait vraiment pas passer par ici, car a voudrait dire que la
			// base de donnes n'a pas pu tre ouverte prcdemment. Si la table demande
			// n'est pas dans la base de donnes, une exception est toujours leve.
			// On va donc lever la mme exception que pour la base de donnes inaccessible.
			AfxThrowDBException(AFX_SQL_ERROR_CONNECT_FAIL, NULL, NULL);
			}
		}
	catch (CDBException* dbE)
		{
		AfxMessageBox("Accs impossible  la base de donnes :\n\n"
			          + dbE->m_strError
					  +"\nLe programme va se terminer.", MB_ICONSTOP);
		dbE->Delete(); // Toujours  faire... avec les drivs de CException...

		exit(0);  // Gnre une petite fuite de memoire... pas grave car rcupre par
		          //  Windows. On pourrait aussi relancer l'exception par throw; (avant
		          //  le Delete), mais le message La cration d'un document vide a chou
				  //  apparat (pas trs intressant et la fuite de mmoire persiste !)
		          //  Si on veut vraiment viter la fuite, on pourrait lever une exception
		          //  personnelle, la capter dans InitInstance et y retourner FALSE. Je ne
		          //  crois pas que a ajoute quelque chose d'utile au programme.
		}

	m_programmesModifies= true;
	}

COdbcDoc::~COdbcDoc()
	{
	m_progCourant.Close();	// Il faut fermer les tables avant la bd...
	m_demos.Close(); 
	}

BOOL COdbcDoc::OnNewDocument()
	{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
	}


/////////////////////////////////////////////////////////////////////////////
// COdbcDoc serialization

void COdbcDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// COdbcDoc diagnostics

#ifdef _DEBUG
void COdbcDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void COdbcDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COdbcDoc commands

void COdbcDoc::ChargerListeProgrammes(CComboBox & p_s_listeProg)
	{
	if (!m_programmesModifies) return;  // Pour performance accrue...
	m_programmesModifies= false;

	p_s_listeProg.ResetContent();

	CLesProg tableProg(&m_demos);
	tableProg.Open(CRecordset::forwardOnly); // Pour viter des conflits (peut-tre)...
	
	while (!tableProg.IsEOF())
		{
		p_s_listeProg.AddString(tableProg.m_titre);
		tableProg.MoveNext();
		}
	}

bool COdbcDoc::FormaterDonneesCourantes(CString & p_s_theme, CString & p_s_dateModif)
	{
	p_s_theme= m_progCourant.m_theme;
	p_s_dateModif= m_progCourant.m_derniereModification.Format("%x");
	return true;
	}

void COdbcDoc::ChangerProgCourant(CString p_titreProg)
	{
	m_progCourant.m_titreChoisi= p_titreProg;
	m_progCourant.Requery();
	}

void COdbcDoc::AjouterProgramme(CString p_titre, CString p_theme, int p_annee, int p_mois, int p_jour)
	{
	m_progCourant.AddNew();
	m_progCourant.m_titre= p_titre;
	m_progCourant.m_theme= p_theme;
	m_progCourant.m_derniereModification= CTime(p_annee, p_mois, p_jour, 0,0,0);
	m_progCourant.Update();
	m_programmesModifies= true;
	}

void COdbcDoc::ModifierProgramme(CString p_titre, CString p_theme, int p_annee, int p_mois, int p_jour)
	{
	m_progCourant.m_titreChoisi= p_titre;
	m_progCourant.Requery();
	m_progCourant.Edit();
	// m_progCourant.m_titre= p_titre; // Ne devrait pas changer...
	m_progCourant.m_theme= p_theme;
	m_progCourant.m_derniereModification= CTime(p_annee, p_mois, p_jour, 0,0,0);
	m_progCourant.Update();
	// m_programmesModifies= true; // Car le titre ne change pas...
	}

void COdbcDoc::RetirerProgramme(CString p_titre)
	{
	m_progCourant.m_titreChoisi= p_titre;
	m_progCourant.Requery();
	m_progCourant.Delete();
	m_programmesModifies= true;
	}

int COdbcDoc::NbSujetsDe(CString p_titreProg)
	{
	// Normalement on prendrait un recordset spcifique (par exemple avec un SQL count 
	// dedans). Pour l'exemple, on va faire autrement afin de montrer l'utilisation
	// d'un nonc SQL dans Open et la boucle ncessaire pour GetRecordCount :
	CLesSujets sujets(&m_demos);
									// N.B. SELECT * ne marche pas
	sujets.Open(CRecordset::snapshot, "SELECT Sujet, Titre, Fichier, Ligne " 
		                              "FROM Sujets "
									  "WHERE Titre = \'" + p_titreProg+'\'');

	// Il faut se rendre au dernier pour que GetRecordCount donne la bonne valeur (il
	// serait ensuite correct tant qu'on ne ferme pas le recordset (les ajouts et
	// retraits sont compts correctement);
	while (!sujets.IsEOF()) 
		sujets.MoveNext();

    // return sujets.GetRecordCount();   
	// *** ->> On va voir une autre technique

	// Une autre technique tout aussi incorrecte car on pourrait faire un
	// recordset avec paramtre pour trouver directement la bonne donne. Mais
	// je veux montrer qu'on peut se promener normalement dans le rsultat d'un
	// SELECT donnant des valeurs qui ne sont pas dans la bd (ici le compte).
	CLesNbSujetsParProg nspp(&m_demos);  // Donne une table Titre NbSujets
	nspp.Open();

	while (!nspp.IsEOF() && nspp.m_titre != p_titreProg)
		nspp.MoveNext();

	if (nspp.IsEOF()) 
		return 0;

	ASSERT(sujets.GetRecordCount() == nspp.m_nbSujets);

	return nspp.m_nbSujets;
	}
