// OdbcView.cpp : implementation of the COdbcView class
//

#include "stdafx.h"
#include "Odbc.h"

#include "OdbcDoc.h"
#include "OdbcView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COdbcView

IMPLEMENT_DYNCREATE(COdbcView, CFormView)

BEGIN_MESSAGE_MAP(COdbcView, CFormView)
	//{{AFX_MSG_MAP(COdbcView)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelChangeProgrammes)
	ON_COMMAND(ID_AJOUTERPROGRAMME, OnAjouterProgramme)
	ON_COMMAND(ID_RETIRERPROGRAMME, OnRetirerProgramme)
	ON_UPDATE_COMMAND_UI(ID_RETIRERPROGRAMME, OnUpdateRetirerProgramme)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COdbcView construction/destruction

COdbcView::COdbcView()
	: CFormView(COdbcView::IDD)
{
	//{{AFX_DATA_INIT(COdbcView)
	m_titreChoisi = _T("");
	m_dateModifStr = _T("");
	m_theme = _T("");
	//}}AFX_DATA_INIT
	// TODO: add construction code here

}

COdbcView::~COdbcView()
{
}

void COdbcView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COdbcView)
	DDX_Control(pDX, IDC_COMBO1, m_listeProg);
	DDX_CBString(pDX, IDC_COMBO1, m_titreChoisi);
	DDX_Text(pDX, IDC_MODIF, m_dateModifStr);
	DDX_Text(pDX, IDC_THEME, m_theme);
	//}}AFX_DATA_MAP
}

BOOL COdbcView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// COdbcView diagnostics

#ifdef _DEBUG
void COdbcView::AssertValid() const
{
	CFormView::AssertValid();
}

void COdbcView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

COdbcDoc* COdbcView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(COdbcDoc)));
	return (COdbcDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// COdbcView message handlers

void COdbcView::OnInitialUpdate() 
	{
	m_pDoc= GetDocument();

	CFormView::OnInitialUpdate();
	}

void COdbcView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
	{
	m_pDoc->ChargerListeProgrammes(m_listeProg);

	if (m_titreChoisi.IsEmpty() && m_listeProg.GetCount() > 0)
		m_listeProg.GetLBText(0, m_titreChoisi);

	AfficherProgrammeCourant();
	}

void COdbcView::OnSelChangeProgrammes() 
	{
	UpdateData(TRUE); // Pour avoir le titreChoisi
	AfficherProgrammeCourant();
	}

void COdbcView::AfficherProgrammeCourant()
	{
	if (m_titreChoisi.IsEmpty())
		{
		m_theme= "";
		m_dateModifStr= "";
		}
	else
		{
		m_pDoc->ChangerProgCourant(m_titreChoisi);
		m_pDoc->FormaterDonneesCourantes(m_theme, m_dateModifStr);
		}

	UpdateData(FALSE);
	}

void COdbcView::OnAjouterProgramme() 
	{
	//CSaisieProgramme d(m_pDoc);

	// if (IDOK == d.DoModal())
		{
	//	int an, mois, jour;
	//	d.Extraire(m_titreChoisi, m_theme, an, mois, jour);
	//	m_pDoc->AjouterProgramme(m_titreChoisi, m_theme, an, mois, jour);
		m_pDoc->AjouterProgramme(m_titreChoisi= "Bidon", "Theme bidon", 1999, 11, 16);
		m_listeProg.AddString(m_titreChoisi);
		AfficherProgrammeCourant();
		}
	}

void COdbcView::OnRetirerProgramme() 
	{
	if (IDYES == AfxMessageBox("tes-vous certain de vouloir enlever le programme "
		                      + m_titreChoisi + " ?", MB_YESNO))
		{
		if (m_pDoc->NbSujetsDe(m_titreChoisi) > 0)
			AfxMessageBox("Ce programme a des sujets associs."
			              "Veuillez d'abord les dtruire.", MB_ICONINFORMATION);
		else
			{
			m_pDoc->RetirerProgramme(m_titreChoisi);
			m_listeProg.DeleteString(m_listeProg.GetCurSel());
			m_titreChoisi= "";           // L'cran sera vide... un choix discutable...
			AfficherProgrammeCourant();
			}
		}
	}

void COdbcView::OnUpdateRetirerProgramme(CCmdUI* pCmdUI) 
	{
	pCmdUI->Enable( ! m_titreChoisi.IsEmpty());
	}
